/*
    Header file for interruptHandler.cpp
*/

//  Prototypes
void trf797xSetupIrq(void);
void trf797xReadIrqStatus(uint8_t *buffer);
void trf797xResetIrqStatus(void);
void trf797xNfcModeIsr(uint8_t *Register);
void trf797xTargetIsr(uint8_t *Register);
void trf797xISR(uint8_t *irq_status);
void trf797xIrqHandler(void);

//  NFC and tag emulation settings
#define NFC106AC    0x29
#define NFC212AC    0x2A
#define NFC424AC    0x2B
#define NFC106PA    0x21
#define NFC212PA    0x22
#define NFC424PA    0x23

#define TAG14443A   0x24
#define TAG14443B   0x25
#define TAG15693    0x26
#define TAGFelica   0x27

#define TAG106      0x00
#define TAG212      0x21
#define TAG424      0x42
#define TAG848      0x63

#define FIFO_LEN    32
#define FIFO_MORE   26

